:userdoc.
:title.Major Major documentation
:docprof toc=12.

.***********************************
.*   INTRODUCTION
.***********************************

:h1.Introduction

:p.
Major Major is a mailing list manager.  It allows you to set up
one or more mailing lists, and it allows people to subscribe to those
lists.  When mail comes in for the list, Major Major sends a copy
to everyone on the list.
:p.
It is distributed as :link reftype=hd refid=register.optional shareware:elink..
:p.This documentation is for version 1.00.

:p.
:hp2.Disclaimer of Warranty:ehp2.

:sl compact.
:li.
:hp1.
This Product is provided "as-is", without warranty of any
kind, either expressed or implied, including, but not limited to,
the implied warranties of merchantability and fitness for a
particular purpose.  The entire risk as to the quality and
performance of the Product is with you.  Should the Product prove
defective, the full cost of repair, servicing, or correction lies
with you.
:ehp1.
:esl.

:p.
The author of Major Major is Peter Moylan, peter@ee.newcastle.edu.au.

:p.
The latest version of Major Major is normally kept at ftp&colon.&slash.&slash.eepjm.newcastle.edu.au/software.
Information about other software on this site may be found at
http&colon.&slash.&slash.eepjm.newcastle.edu.au/os2.

:p.
:hp2.Getting information about new versions:ehp2.

:p.
You can, if you wish, join a mailing list for announcements about
new releases of my software.  There are two lists: software-announce,
which is purely for such announcements, and majormajor-list, which is a
general forum for discussions and questions about Major Major.  To join
one or both of these, send an
e-mail to majormajor@eepjm.newcastle.edu.au.  The subject line is not
important and may be anything.  In the body of the message, put the
lines
:xmp.       subscribe software-announce
       subscribe majormajor-list
       end
:exmp.

:p.(To join only one of the two lists, use only one "subscribe"
command.)  To have yourself removed from a list, send a similar e-mail but
using the command "unsubscribe" instead of "subscribe".

.***********************************
.*   REGISTRATION
.***********************************

:h1 id=register.Registration

:hp2.Registration:ehp2.

:p.This software is "optional shareware".  What this means is that you
decide whether you want to register as a paid owner of the software.
The software is not crippled in any way, and I will continue to provide
support and free releases of new versions to all users, whether or
not they are registered, for at least the short-term future.

:p.If you decide that this software is worth supporting, you have the
following payment options.
:p.
:hp2.Payment through BMT Micro:ehp2.

:p.This is likely to be the most convenient method for most people,
because BMT Micro has a number of different payment methods, including
credit cards.  It also has agents in several countries.  For full
details, see the file register.bmt included in the Major Major distribution.
The price is $20 (US dollars).

:p.
:hp2.From Europe:ehp2.

:p.This works best for people living in the European Union.  (Warning:
check first whether your bank is going to charge you transfer fees.)
You have two options:
:ul.
:li.Transfer 20, or the equivalent in Belgian francs, to the following bank account
:sl.
:li.Marion Gevers
.br
Account number 220-0586389-60
.br
G&ea.n&ea.rale de Banque (Belgium)
.br
Mention: Major Major
:esl.
:p.and send an e-mail to peter@ee.newcastle.edu.au to confirm that you've done it.

:li.Send a Eurocheque for 20, or the equivalent in Belgian francs, to
:sl.
:li.Marion Gevers
.br
91 Harriet Street
.br
Waratah, NSW 2298
.br
Australia
:esl.
:eul.

:p.
:hp2.Payment directly to me in Australia:ehp2.

:p.This is a more attractive option for people in Australia.  From
other countries, it's not a good idea because of the bank charges on
international transfers.  (Please don't send non-Australian currency
to an Australian bank, because then I get hit with exorbitant bank fees.)
You can do it in either of two ways.

:ul.
:li.Send a cheque, or equivalent, for $25 (Australian dollars) to
:sl.
:li.Peter Moylan
.br
91 Harriet Street
.br
Waratah, NSW 2298
.br
Australia
:esl.

:li.Transfer the amount of $25 (Australian dollars) to the following bank
account.
:sl.
:li.Marion Gevers
.br
Account number (06 2831) 00626468
.br
Commonwealth Bank
.br
University of Newcastle, Australia
:esl.
:eul.

.***********************************
.*   HOW IT WORKS
.***********************************

:h1.How it works

:hp2.What is a mailing list?:ehp2.

:p.
A mailing list is similar to a newsgroup, except that it uses e-mail
rather than Usenet to transport the messages.  People join the list
by mailing a "subscribe" command to the mailing list manager.  If
they later want to leave the list, they send in an "unsubscribe"
command.
:p.
The name of the list is an e-mail address.  That is, it has the form
"listname@domain", where "domain" is the mail domain for the mail
server that receives mail for the list.  You send a message to the
list by mailing it to that address.  When it is received, the list
manager sees it and sends copies to everyone who is subscribed to
the list.  In other words, when you send an e-mail to the list you
are actually sending it to multiple people.

:p.:hp2.Major Major and its interaction with the mail server:ehp2.

:p.
A mail server consists of two parts.  (These might be two separate
pieces of software, or they might be integrated in a single package.)
One part is the SMTP software, which is the software that looks after
transferring mail between the source and destination machines.  The
other part is the "Post Office" server, through which users pick up
their mail after it has arrived.  Major Major assumes that the
Post Office server is a POP3 server, which at least for now is the
most common kind of Post Office server.

:p.
One way to implement a mailing list manager would be to make it an
integral part of the mail server software.  I haven't done it this
way, however, because I dislike large integrated software packages.
Rather than have one giant program that does everything, I prefer
to have many small programs, each of which does one thing and
does it well.  That gives a cleaner design, with less chance of
undetected software errors.  It also means that the users can
"mix and match" their software, according to their own preferences,
without having to get it all from the same supplier.

:p.
As a result of this, Major Major is :hp1.not:ehp1. itself a mail
server.  It assumes that a mail server is already installed, and
it interacts with that mail server.  When mailing list mail arrives
at the Post Office machine, Major Major gets it from the POP3
server.  Then Major Major decides who it should be forwarded to,
and it sends it back to the SMTP server to be delivered.

:p.
When you set up a mailing list, you specify to Major Major how
often it should check for mail.  Most mailing lists don't need a
rapid response, so it would be sufficient to check them once an
hour or even once a day.  In the case of a discussion list that
has lively back-and-forth discussions, you might want to cut the
sampling interval down to a few minutes.  In an extreme case
you might even reduce it to a few seconds; but that is not
recommended, because it puts an extra load on your processor.

:p.
Major Major can handle multiple mailing lists, and you can set
different sampling intervals for different lists.

:p.:hp2.Special case: the interaction with Weasel:ehp2.

:p.
If you are using the Weasel mail server, and it is running on the
same machine as Major Major, a shortcut is possible.  In this
case, Major Major doesn't need to use the POP3 and SMTP protocols
to send and receive mail.  Instead, it looks directly into the
disk directories where Weasel stores the mail.  This removes
some overhead from the operation, because you don't have as much
network traffic.


.***********************************
.*   INSTALLATION
.***********************************

:h1.Installation
:hp2.Installation:ehp2.
:p.
See also :link reftype=hd refid=deinstall.De-installation:elink.

:p.You should have received this package in the form of a zip file.
The first step is to unzip the file into a directory of your choice.
(Presumably you've already done this.)  You will find that you
have executable files Major.exe and Admin.exe, and a few other
files.

:p.Admin.exe sets up the configurable parameters, so you should
run it first.  The required settings should be obvious.  If they're
not, you can refer to the :link reftype=hd refid=Configuration.configuration:elink.
section of this manual.

:p.Major.exe is the actual mailing list manager, and you leave
it running all the time.  Ultimately you will probably want to
run it minimized or detached, but initially it's a good idea
to run it directly on your desktop, so that you can verify that
it's doing what you expect.

:p.If you need to stop Major.exe, type CTRL/C.  A process killer,
e.g. the second button in the WarpCenter, will also work, but
CTRL/C is preferred because it makes Major Major tidy up and
exit cleanly.

:p.The command file MakeFolder.cmd is optional.  If you run it,
it will create a desktop folder to let you work with Major Major
without having to open the directory in which it's installed.

:p.Of course, Major Major is not going to do anything interesting
until you've created one or more mailing lists, and this includes
creating the e-mail accounts for those lists.  Those details
are covered in the following sections.

.***********************************
.*   DEINSTALLATION
.***********************************

:h1 id=deinstall.De-installation
:hp2.De-installation:ehp2.
:p.
Major Major does not tamper with CONFIG.SYS or with other system files.
If you decide that you don't want to keep Major Major, simply delete
the directory into which you installed it.

:p.You should probably also go to your mail server and close down
the e-mail accounts that you were using for Major Major, unless
of course you still need those accounts.

.***********************************
.*   SETTING UP THE E-MAIL ACCOUNTS
.***********************************

:h1.Setting up the e-mail accounts
:hp2.Setting up the e-mail accounts:ehp2.

:p.Major Major needs one e-mail account for itself, plus one account
for each mailing list it is managing.  The account that Major Major
reserves for itself is the one that receives the administrative
commands such as "subscribe" and "unsubscribe".  The other accounts
are the ones that receive the mailing list traffic.

:p.To provide these accounts, you have basically two choices.
:ul.
:li.You can use an existing e-mail server, and ask the manager of
that server to create the accounts for you.  You might have to pay
for these accounts, depending on your service provider's rules.
:li.Alternatively, you can become your own postmaster by installing
a mail server on your own computer.  To do this, you must of course
have enough network connectivity to send and receive mail.
:eul.

:p.Major Major does not have to be physically on the same machine
where the mail server is running.

.***********************************
.*   CONFIGURATION
.***********************************

:h1 id=configuration.Configuration

:p.The program called Admin.exe is what you use to configure Major
Major.  When you run Admin.exe, you get a notebook with the
following pages.

:ul.
:li.:link reftype=hd refid=Basic.Basic:elink. - some overall program settings.
:li.:link reftype=hd refid=Admin.Admin:elink. - settings for the Major Major administrator.
:li.:link reftype=hd refid=Messages.Messages:elink. - the file names for some standard messages
:li.:link reftype=hd refid=Lists.Lists:elink. - creation and deletion of mailing lists.
:li.:link reftype=hd refid=About.About:elink. - identifies the program version.
:eul.

.***********************************
.*   BASIC
.***********************************

:h2 id=Basic.Basic settings
:hp2.Basic settings:ehp2.

:p.Changes made on this page will not have any effect until you restart
Major Major.

:p.:hp2.Server and domain:ehp2.

:p.The first thing you have to specify on this page is whether you are using
the Weasel mail server, running on the same machine as Major Major, as your
mail server.  You do this by selecting one of two radio buttons.  If you choose
"Weasel on this machine", Major Major will send and receive mail by direct
manipulation of the Weasel mail directories.  If you choose "Other mail server",
Major Major will use the SMTP and POP3 protocols to send and receive mail.

:p.The mail domain name is what comes after the '@' sign in the e-mail address
used by Major Major.  Commonly this is just the hostname of the machine on which
the mail server is running, but it is also possible for a single mail domain to
have multiple mail servers; in this case the mail domain name is, in effect, an
identifier for the group.

:p.The main use for this field within Major Major is in constructing the
"Reply-To" header line that is part of every e-mail sent out.

:p.:hp2.Root directory for mail:ehp2.

:p.This is needed only if you have selected the "Weasel on this machine" option.  It
should specify the full path name of the disk directory that Weasel uses for
storing mail.

:p.:hp2.SMTP and POP3 servers:ehp2.

:p.These must be specified if you have selected the "Other mail server" option.
The SMTP server is used for sending mail out, and the POP3 server is for incoming
mail.  Often these are on the same machine, but this is not compulsory.

:p.For each server you have to specify a hostname and a port number.  The
standard port number for an SMTP server is 25, and the standard port number for
a POP3 server is 110.  Do not use different port numbers unless the postmaster
tells you to.

:p.:hp2.Logging:ehp2.

:p.If you want to keep a log of the Major Major operations, select one or both
of the checkboxes in this section.  You can choose to have the log written to
the screen, or to a disk file called MAJOR.LOG, or to both.

.***********************************
.*   ADMIN
.***********************************

:h2 id=Admin.Admin
:hp2.Admin&colon. settings for the Major Major administrator:ehp2.

:p.The administrator is the part of Major Major that receives and processes commands
such as "subscribe".  Changes made on this page will not have any effect until you restart
Major Major.

:p.:hp2.E-mail account for the administrator:ehp2.

:p.Here you specify the username and POP3 password for the e-mail account that
receives mail for the administrator.  Enter the details here as specified by
your postmaster.  These fields might or might not be case-sensitive, depending
on the mail server.

:p.The default assumption is that the username is "MajorMajor", but you can
choose some different name if you prefer and/or if your postmaster requires it.

:ul.
:li.Special case 1&colon. If you have selected "Weasel on this machine" as your mail
server, the password is not needed.
:li.Special case 2&colon. Some multi-domain POP servers require you to log in with
a string of the form "username@domain" as the username.  If so, you should
include this complete string in the username field here, and you should leave
the mail domain field on the Basic page blank.
:eul.

:p.:hp2.Time between checks:ehp2.

:p.This specifies how often the Major Major administrator will check for new
mail for itself.  (This has nothing to do with the times for checking the
mailing lists.  The time is set independently for each list.)  Typically
this is not urgent mail, so you don't need frequent checks.

.***********************************
.*   MESSAGES
.***********************************

:h2 id=Messages.Messages
:hp2.Messages&colon. names of files containing some standard messages:ehp2.

:p.Each entry on this page contains the name of a file.  The file contains
a message that will be e-mailed as a reply to certain operations.  You
can choose to use the default messages in the "Canned" subdirectory, or
you can write your own versions.  If you write your own, give them file
names or directories that are different from the the default file names;
otherwise, you risk having your modifications overwritten when you install
a new version of Major Major.

:p.:hp2.Message when non-subscriber attempts to post:ehp2.

:p.This file should contain the reply that will be sent to someone who
attempts to send a message to a list that they're not allowed to
write to.  The first line is normally a "Subject:" line.  After this
you can add more header lines if you wish.  After the header lines there
should be a blank line, and then the body of the message.

:p.:hp2.Response to HELP command:ehp2.

:p.This file should contain the text that will be sent back to a user
in response to a HELP command.  There are no header lines.

.***********************************
.*   LISTS
.***********************************

:h2 id=Lists.Lists
:hp2.Lists&colon. creation and deletion of mailing lists:ehp2.

:p.The listbox on this page lists all the mailing lists that are currently
defined.  Changes made on this page will take effect immediately; it will
not be necessary to restart Major Major.

:p.:hp2.Adding a new mailing list:ehp2.

:p.To create a new list, click on the "Add" button.  You will be asked
to enter a name for the list.  Type in the name, finishing with the
<Enter> key.  You may then proceed to
:link reftype=hd refid=EditList.edit the list properties:elink..

:p.:hp2.Editing the properties of an existing mailing list:ehp2.

:p.To edit a list, first select that list (e.g. by clicking on its
name with the left mouse button), and then click on the "Edit" button.
Then proceed as described in the section on
:link reftype=hd refid=EditList.editing the list properties:elink..

:p.Instead of selecting the "Edit" button, you may also double-click
on the list name.

:p.:hp2.Changing the name of an existing mailing list:ehp2.

:p.To rename a list, first select that list (e.g. by clicking on its
name with the left mouse button), and then click on the "Rename" button.
You will then see a small entry box where you can edit the name.
Type the <Enter> key when you have finished.  This operation changes
only the name of the list, and therefore its e-mail address.  All other
properties of the list are kept unchanged.

:p.:hp2.Deleting an existing mailing list:ehp2.

:p.To delete a list, first select that list (e.g. by clicking on its
name with the left mouse button), and then click on the "Delete" button.

:p.Warning: there is no way to undo this operation.  As a safety measure,
it is a good idea to use the
:link reftype=hd refid=DumpINILoadINI.DumpINI:elink. utility to create a
backup copy of your data.

.***********************************
.*   ABOUT
.***********************************

:h2 id=About.About
:hp2.About:ehp2.

:p.The function of the "About" notebook page is to identify the author, and to tell you
what version of the program you have.

.***************************************
.*   EDITING THE MAILING LIST PROPERTIES
.***************************************

:h1 id=EditList.Defining the properties of a mailing list
:hp2.Defining the properties of a mailing list:ehp2.

:p.You reach this point by going to the "Lists" page in the Admin
notebook and choosing the "Add" or "Edit" option.  This opens up a
new notebook with the list properties.

:p.The book has the following pages.

:ul.
:li.:link reftype=hd refid=ListBasic.Basic settings:elink.
:li.:link reftype=hd refid=ListMessages.Messages:elink.
:li.:link reftype=hd refid=ListMembers.Members:elink.
:eul.

:p.Any changes you make will come into effect once you close the list notebook.
It is not necessary to restart Major Major.

.***************************************
.*   LIST NOTEBOOK: BASIC PAGE
.***************************************

:h2 id=ListBasic.Basic settings
:hp2.Basic properties of the list:ehp2.

:p.The settings on this page define some basic properties of the list.

:dl break=all.
:dt.POP3 password
:dd.This is the password that is needed to log in to the POP3 server and
fetch mail.  It will have been assigned to you by the person in charge
of the mail server.  In the special case where you have specified
"Weasel on this machine" as your mail server, a POP3 password is not
needed.
:dt.Abbreviated list name
:dd.Here you can specify an abbreviation for the list name, up to
eight characters long. This will appear in brackets at the beginning
of the "Subject:" line when mailings are distributed to the list
subscribers.
:dt.Check for new mail
:dd.Specify here how often the POP3 server is to be checked for new
mail to this list.  Making this time too short can put an unreasonable
load on your processor.  A time in the range 1 to 10 minutes is a
reasonable compromise.  If list messages are not particularly urgent
you could even reduce this to once per day.
:dt.Error messages
:dd.Error messages will be produced by the receiving SMTP servers when,
for example, somebody subscribes to the list with an invalid address.
You can specify "discard" to say that these messages should be ignored,
or you can specify an e-mail address to receive such messages.
:dt.Mail from non-subscribers
:dd.Here you have to decide whether people not subscribed to the list
should be able to post messages to the list.  Choose "Accept" if you
want to permit this.  Choose "Reject" if you want to refuse the message
and send an error message back to the sender.  Most commonly you will
want to choose "Ignore", which is like "Reject" except that no error
message is sent back.  This is because a lot of junk mail software
takes a reply as a confirmation that this e-mail account is active
and able to receive more junk mail.
:dt.Moderation options
:dd.If you tick the "Moderated" box, this list becomes a moderated
list.  In a moderated list only one person, called the moderator, may
post messages to the list.  You should specify the moderator's e-mail
address in the entry field below the "Moderated" checkbox.  If
anyone else sends mail to a moderated list, that mail will be sent
to the moderator rather than to the whole list.
:p.If you tick the "Controlled subscription" box, this will prevent
the "subscribe" command from working for this list.  There is one
exception: if there is a moderator then the moderator may use the
"subscribe" command to subscribe other people.  (This is true even
if the list is not a moderated list.)

:p.If either or both of these options is enabled, you should fill
in the e-mail address of the moderator in the "moderator" field.
:dt.Filter
:dd.The entry in the "Filter" field, if present, should be the name
of an executable program or of a Rexx script that will filter the
incoming messages.  The filter takes one parameter, which is the
name of a file that contains the incoming message.  The filter may
modify the message, but it should not change the file name.  If the
reply code from the filter is zero, the (possibly modified) message
will be delivered to all subscribers to the list.  If the reply
code is nonzero, the message will be deleted and not delivered.

:edl.

.***************************************
.*   LIST NOTEBOOK: MESSAGES
.***************************************

:h2 id=ListMessages.Messages
:hp2.Messages for this list:ehp2.

:p.This page is for specifying the file names of message files for
use with this list.  All of these are optional.  Leave the name
blank if you do not want to use the option.

:dl break=all.
:dt.Welcome message
:dd.This is the name of a file that contains a message that will be
sent to all new subscribers to this list.  (That is, it will be sent
whenever a 'subscribe' command is successful.)  The message should
start with a "Subject:" line, plus any other optional header lines
you want to add.  Then there should be a blank line, followed by the
text of the welcome message.
:dt.Footer file
:dd.This file contains a message that will be appended to all list
messages as they are sent out.  It would normally contain a signature
line, or a message saying how to unsubscribe from the list, or
something similar.
:edl.

.***************************************
.*   LIST NOTEBOOK: MEMBERS PAGE
.***************************************

:h2 id=ListMembers.Members
:hp2.Subscribers to this list:ehp2.

:p.Normally the subscribe/unsubscribe operations are handled by the
list members themselves.  They send an e-mail to put themselves on
the mailing list or to remove themselves from the list.  There might,
however, be times when you want to make changes manually.

:p.:hp2.Adding a new member:ehp2.

:p.Click on the "Add" button, and type in an e-mail address.  Finish with
the Enter key to confirm your entry, or with the Esc key to cancel the
operation.

:p.:hp2.Changing an existing entry:ehp2.

:p.Click on the entry to be changed, click on the "Revise" button, and edit the
e-mail address.  Finish with
the Enter key to confirm your entry, or with the Esc key to leave the
original entry unchanged.

:p.:hp2.Deleting an existing member:ehp2.

:p.Click on the entry to be deleted, then click on the "Delete" button.

:p.Double-clicking on a list entry has the same effect as selecting the
"Revise" button.

.***************************************
.*   COMMANDS TO THE LIST ADMINISTRATOR
.***************************************

:h1 id=AdminCommands.Commands to the list administrator
:hp2.Commands to the list administrator:ehp2.

:p.List subscribers and potential subscribers interact with Major Major
by sending it an e-mail message.  The "Subject:" header of the message
is not important, because Major Major ignores everything in the header
except the "From:" address.  The body of the message contains one
or more commands, which are explained on this page.  Whitespace (empty
lines or space characters before the commands) is ignored.

:dl break=all.
:dt.:xmp.subscribe listname emailaddress
:exmp.
:dd.This is how you subscribe someone to a list.  The first parameter is
the name of the list, and the second parameter is the e-mail address of
the person to be subscribed.
:dt.:xmp.subscribe listname
:exmp.
:dd.This is the same as the above, except that the e-mail address of the
new subscriber is taken from the "From:" line of the request.
:dt.:xmp.unsubscribe listname emailaddress
:exmp.
:dd.This is how you remove someone from a list.  The first parameter is
the name of the list, and the second parameter is the e-mail address to
be removed from the subscriptions.
:dt.:xmp.unsubscribe listname
:exmp.
:dd.This is the same as the above, except that the e-mail address to be
removed is taken from the "From:" line of the request.
:dt.:xmp.help
:exmp.
:dd.This command causes a help message to be sent back to the person
sending the mail.
:dt.:xmp.end
:exmp.
:dd.Specifies that there are no more commands.  This ensures that Major
Major does not try to process things like signature blocks.  If the
'end' command is missing, processing stops either at the end of the
e-mail or at a line starting with a '-' character, whichever comes first.
:edl.

.***************************************
.*   DUMPINI AND LOADINI
.***************************************

:h1 id=DumpINILoadINI.The DumpINI and LoadINI utilities

:p.All of the configuration data for Major Major, including details such
as the list of all e-mail addresses for a mailing list, is kept in a
binary file called MAJOR.INI.  The two programs described on this page
allow you to save this data in "plain text" form for backup purposes.
This also gives you the possibility of manually editing the data, for
example when trying to create a mailing list from an address book in
your e-mail software.

:p.:hp2.DumpINI:ehp2.

:p.The DumpINI program reads MAJOR.INI and creates a new file called
MAJOR.TNI.  This new file contains the same data, but in human-readable
form.

:p.:hp2.LoadINI:ehp2.

:p.The LoadINI program reads MAJOR.TNI and loads the information back
into the main INI file called MAJOR.INI.  It is possible to use this
when MAJOR.TNI contains only a subset of the data, because existing
entries in MAJOR.INI are not deleted except when they are superseded
by new information in MAJOR.TNI.

:h1.Who was Major Major?

:hp2.Who was Major Major?:ehp2.

:p.Major Major's full name was Major Major Major.  He was given
that name by his father.  Here is a quote from the novel
:hp1.Catch-22:ehp1., by Joseph Heller.

:lm margin=6.
:rm margin=10.
:font facename='Helv' size=14x8.

:p.A lesser man might have wavered that day in the hospital
corridor, a weaker man might have compromised on such excellent
substitutes as Drum Major, Minor Major, Sergeant Major, or
C. Sharp Major, but Major Major's father had waited fourteen
years for just such an opportunity, and he was not a person
to waste it.
:rm margin=1.
:lm margin=1.
:font facename=default.

:p.When Major Major grew up, he joined the Army.  Four days
later, he was promoted to the rank of Major by a computer error.

:p.:hp1.Catch-22:ehp1. is one of the great books of 20th
century English literature.  If you haven't yet read it,
try to find a copy.

:euserdoc.

